///////////////////////////////////////////////////////////////////////////////////////+
//=====================================================================================+
//+------------------------------------------------------------------------------------+
//|                                                                          HA2MA.mq4 |
//|                                           Copyright ╘ 2008, Vladislav Goshkov (VG) |
//|                                                                     4vg AT mail.ru |
//+------------------------------------------------------------------------------------+
//=====================================================================================+
///////////////////////////////////////////////////////////////////////////////////////+
#property copyright "Copyright ╘ 2008 Vladislav Goshkov (VG)"
#property link      "4vg AT mail.ru"

///////////////////////////////////////////////////////////////////////////////////////+
//=====================================================================================+
//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+
//=====================================================================================+
///////////////////////////////////////////////////////////////////////////////////////+

#property indicator_separate_window
#property indicator_minimum -0.05
#property indicator_maximum 1.05
#property indicator_buffers 4
#property indicator_color1 MediumBlue
#property indicator_width1 2
#property indicator_color2 Crimson
#property indicator_width2 2
#property indicator_color3 LightBlue
#property indicator_width3 2
#property indicator_color4 Orange
#property indicator_width4 2

//---- input parameters
extern int    IndTF = 0;
extern int    MaPeriod1 = 6;
extern double t3b1  = 0.5;
extern double PctFilter1=0.5; 
extern double Deviation1=0.0;
extern int    MaMetod1  = 2;//MODE_EMA
extern int    MaPeriod2 = 2;
extern double t3b2  = 0.5;
extern double PctFilter2=0.0; 
extern double Deviation2=0.0;
extern int    MaMetod2  = 3;//MODE_EMA
extern int    BarsCNT   = 1500;
extern int    bn        = 0;
//---- indicator buffers
double HA2MAUp1[];
double HA2MADn1[];
double HA2MAUp2[];
double HA2MADn2[];

string symb="";
int    CurP = -1;
int    ArrSize = 112;//167;//158;//159;
//SetIndexArrow(7,ArrSize);
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line

   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,2);
  
   SetIndexBuffer(0,HA2MAUp1); //SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,ArrSize);
   SetIndexBuffer(1,HA2MADn1); //SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,ArrSize);
   SetIndexBuffer(2,HA2MAUp2); //SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,ArrSize);
   SetIndexBuffer(3,HA2MADn2); //SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,ArrSize);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="VG HA2MA Trend Filter("+ " Period => "+MaPeriod1+ " TimeFrame => "+IndTF+" )";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
   SetIndexLabel(2,"Mild UpTrend");
   SetIndexLabel(3,"Mild DownTrend");
   
//----
   SetIndexDrawBegin(0,MaPeriod1);
   SetIndexDrawBegin(1,MaPeriod1);
   SetIndexDrawBegin(2,MaPeriod1);
   SetIndexDrawBegin(3,MaPeriod1);  
//----
   CurP = Period();
   symb = Symbol();
   return(0);
  }
//#define MAXBARSCOUNT 50000
#include <DebugPrint.mqh>
#include <TradingLib_f_VG.mqh>
//#include <TradingLib_MT_inc.mqh>

//+------------------------------------------------------------------+
int HA2MAmtf(double& iBff1[], double& iBff2[], double& iBff3[], double& iBff4[], 
             string smb, int iTF, 
             int iMaPeriod1, double it3b1, double iPctFilter1, double iDeviation1, int    iMaMetod1,
             int iMaPeriod2, double it3b2, double iPctFilter2, double iDeviation2, int    iMaMetod2,
             int iBarsCNT = 1000, int ifrom=0)
{
double emb1[MAXBARSCOUNT],emb2[MAXBARSCOUNT],emb3[MAXBARSCOUNT],emb4[MAXBARSCOUNT];
int    HA_Trend[MAXBARSCOUNT];
/*
int    copyBars = MathMin(MathMin(MAXBARSCOUNT,Bars),(iBarsCNT+1));
int    bars     = mtfCopyRates(smb,iTF,copyBars);
double res      = -1;
double datr     = -1;
double cppatr   = -1;
    if(bars!=copyBars) 
    {
        Print("Err : Copied ",bars," bars");
        return(bars);
    }
*/
int bars  = CheckCPPBarsCNT(symb,IndTF,iBarsCNT,ifrom, true);
    Print("HA2MAmtf() 2");
    bars--;

    int curHATrend = fHA2MATrend(emb1,emb2,emb3,emb4,
                              HA_Trend,
                              iMaPeriod1,it3b1,iPctFilter1,iDeviation1,iMaMetod1,
                              iMaPeriod2,it3b2,iPctFilter2,iDeviation2,iMaMetod2,
                              bars,ifrom
                              );
    for(int i=0;i<bars;i++)
    {
        datetime bt = Time[i];
        int j = BarShftOnTime(bt); 
        iBff1[i] = emb1[j];
        iBff2[i] = emb2[j];
        iBff3[i] = emb3[j];
        iBff4[i] = emb4[j];
    }
             
    return(iTF);
}

//+------------------------------------------------------------------+
//| HA2MAFilter                                                      |
//+------------------------------------------------------------------+
int mtHA2MALvlsTrend(int &trend[],
             //double& iBff1[], double& iBff2[], double& iBff3[], double& iBff4[], 
             string smb, int iTF, 
             int iMaPeriod1, double it3b1, double iPctFilter1, double iDeviation1, int    iMaMetod1,
             int iMaPeriod2, double it3b2, double iPctFilter2, double iDeviation2, int    iMaMetod2,
             int iBarsCNT = 1000, int ifrom=0)
{
int    i = 0;
double indBff1[MAXBARSCOUNT], indBff2[MAXBARSCOUNT],
       ind_op[MAXBARSCOUNT], ind_cl[MAXBARSCOUNT];

    HA2MAmtf(indBff1,indBff2,ind_op,ind_cl, 
             smb,iTF, 
             iMaPeriod1,it3b1,iPctFilter1,iDeviation1,iMaMetod1,
             iMaPeriod2,it3b2,iPctFilter2,iDeviation2,iMaMetod2,
             iBarsCNT, ifrom);
   for(i=iBarsCNT-1;i>=0;i--)
   {	
	   if( (ind_op[i]>ind_cl[i]) && (indBff1[i]<indBff2[i]) ) trend[i]= -1;
	   if( (ind_op[i]>ind_cl[i]) && (indBff1[i]>indBff2[i]) ) trend[i]= -2;
	   if( (ind_op[i]<ind_cl[i]) && (indBff1[i]>indBff2[i]) ) trend[i]=  1;
	   if( (ind_op[i]<ind_cl[i]) && (indBff1[i]<indBff2[i]) ) trend[i]=  2;
	}
	return(0);	
}

int HA2MALvlFilter(double &Up1[], double &Up2[],
                  double &Dn1[], double &Dn2[], 
                  string smb, int iTF, 
                  int iMaPeriod1, double it3b1, double iPctFilter1, double iDeviation1, int    iMaMetod1,
                  int iMaPeriod2, double it3b2, double iPctFilter2, double iDeviation2, int    iMaMetod2,
                  int iBarsCNT = 1000, int ifrom=0)
{
int trend[MAXBARSCOUNT];
int    i    = 0;

    //mtCCI2LvlsTrend(trend, smb, CCITF, cciP, maMethod, CCIPriceType,barsCNT,from);
    mtHA2MALvlsTrend(trend, smb,iTF, 
                     iMaPeriod1, it3b1, iPctFilter1, iDeviation1, iMaMetod1,
                     iMaPeriod2, it3b2, iPctFilter2, iDeviation2, iMaMetod2,
                     iBarsCNT,ifrom);
    for(i=iBarsCNT-1;i>=0;i--)
    {	
	     if (trend[i]==1) 
	     {
	         Up1[i]=0;
	         Up2[i]=1;
	         Dn1[i]=0;
	         Dn2[i]=0;
	     }
  	     if (trend[i]==2) 
	     {
	         Up1[i]=1;
	         Up2[i]=0;
	         Dn1[i]=0;
	         Dn2[i]=0;
	  	  }
	     if (trend[i]==-1) 
	     {
	         Up1[i]=0;
	         Up2[i]=0;
	         Dn1[i]=0;
	         Dn2[i]=1;
	     }
	     if (trend[i]==-2) 
	     {
	         Up1[i]=0;
	         Up2[i]=0;
	         Dn1[i]=1;
	         Dn2[i]=0; 
	     }
    }
    return(0);
}


int start()
{
static int nT=-1,nB=-1,nP=-1,i=0;

    if((nT==Time[0])&&(nB==Bars)&&(nP==CurP)) return(0);
    nT = Time[0];
    nB = Bars;
    nP = CurP;

    HA2MALvlFilter( HA2MAUp1, HA2MAUp2, HA2MADn1, HA2MADn2 ,
                    symb, IndTF, 
                    MaPeriod1, t3b1, PctFilter1, Deviation1, MaMetod1,
                    MaPeriod2, t3b2, PctFilter2, Deviation2, MaMetod2,
                    BarsCNT, 0 );

	 return(0);	
}

